Skip to main content
PATCH
/
crm-object-schemas
/
v3
/
schemas
/
{objectType}
Update the schema of a specified custom object.
curl --request PATCH \
  --url https://api.hubapi.com/crm-object-schemas/v3/schemas/{objectType} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "primaryDisplayProperty": "my_object_property",
  "requiredProperties": [
    "my_object_property"
  ],
  "searchableProperties": [
    "my_object_property"
  ]
}
'
{
  "createdAt": "2020-02-20T18:07:11.390Z",
  "id": "123456",
  "labels": {
    "plural": "My objects",
    "singular": "My object"
  },
  "metaType": "PORTAL_SPECIFIC",
  "name": "my_object",
  "portalId": 12345678,
  "primaryDisplayProperty": "my_object_property",
  "requiredProperties": [
    "my_object_property"
  ],
  "searchableProperties": [
    "my_object_property"
  ],
  "updatedAt": "2020-02-21T14:13:28.818002Z"
}

Supported products

Authorizations

Authorization
string
header
required

The access token received from the authorization server in the OAuth 2.0 flow.

Path Parameters

objectType
string
required

Fully qualified name or object type ID of your schema.

Body

application/json

Attributes to update in your schema.

Defines attributes to update on an object type.

allowsSensitiveProperties
boolean

Determines if the object type can include properties that are marked as sensitive.

clearDescription
boolean

Indicates whether the description of the object type should be cleared.

description
string

A brief explanation of the object type.

labels
object

Singular and plural labels for the object. Used in CRM display.

Example:
{
"plural": "My objects",
"singular": "My object"
}
primaryDisplayProperty
string

The name of the primary property for this object. This will be displayed as primary on the HubSpot record page for this object type.

requiredProperties
string[]

The names of properties that should be required when creating an object of this type.

restorable
boolean

Specifies if the object type can be restored after being deleted.

searchableProperties
string[]

Names of properties that will be indexed for this object type in by HubSpot's product search.

secondaryDisplayProperties
string[]

The names of secondary properties for this object. These will be displayed as secondary on the HubSpot record page for this object type.

Response

successful operation

Defines an object type.

id
string
required

A unique ID for this object type. Will be defined as {meta-type}-{unique ID}.

labels
object
required

Singular and plural labels for the object. Used in CRM display.

Example:
{
"plural": "My objects",
"singular": "My object"
}
name
string
required

A unique name for this object. For internal use only.

requiredProperties
string[]
required

The names of properties that should be required when creating an object of this type.

allowsSensitiveProperties
boolean

Indicates whether the object type allows properties that contain sensitive data.

archived
boolean

Indicates whether the object type is archived.

createdAt
string<date-time>

When the object type was created.

description
string

A description of the object type.

fullyQualifiedName
string

An assigned unique ID for the object, including portal ID and object name.

objectTypeId
string

A unique identifier for the object type.

portalId
integer<int32>

The ID of the account that this object type is specific to.

primaryDisplayProperty
string

The name of the primary property for this object. This will be displayed as primary on the HubSpot record page for this object type.

searchableProperties
string[]

Names of properties that will be indexed for this object type in by HubSpot's product search.

secondaryDisplayProperties
string[]

The names of secondary properties for this object. These will be displayed as secondary on the HubSpot record page for this object type.

updatedAt
string<date-time>

When the object type was last updated.

Last modified on March 5, 2026